<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="newRecord(modalDatos)" class="btn btn-primary" [disabled]="loading">
    <i class="fa fa-plus mr-2"></i>Nuevo
  </button>
  <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="!gridData.length || loading">
    <i class="fa fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="main-card mb-3 card">
  <div class="card-body">
    <kendo-grid [kendoGridBinding]="gridData" [selectable]="true" [resizable]="true" [navigable]="true"
      [sortable]="true" filterable="menu" [pageable]="{ buttonCount: 5, pageSizes: [10, 25, 50] }" [pageSize]="pageSize" [skip]="0" style="height:74vh;"
      (selectionChange)="valueRow($event, modalDatos)">
      <ng-container *ngIf="gridData.length !== 0">
        <kendo-grid-column field="cuarto" title="Cuarto" [width]="200"></kendo-grid-column>
        <kendo-grid-column field="cfini" title="Fecha Inicio" [width]="230">
          <ng-template kendoGridCellTemplate let-dataItem>
            {{ dataItem.cfini | date: formatKendo }}
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="cfter" title="Fecha Término" [width]="230">
          <ng-template kendoGridCellTemplate let-dataItem>
            {{ dataItem.cfter | date: formatKendo }}
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="crazon" title="Razón" [width]="230"></kendo-grid-column>
        <kendo-grid-command-column width="120">
          <ng-template kendoGridCellTemplate let-dataItem>
            <button class="btn btn-danger" (click)="deleteRecord(dataItem)">
              <i class="fas fa-trash-alt mr-2"></i>Eliminar
            </button>
          </ng-template>
        </kendo-grid-command-column>
      </ng-container>
      <ng-template kendoGridNoRecordsTemplate>{{ norecords }}</ng-template>
    </kendo-grid>
    <ngx-loading [show]="loading" [config]="loadingColor"></ngx-loading>
  </div>
</div>

<ng-template #modalDatos let-c="close" let-d="dismiss">
  <div class="modal-header">
    <div class="modal-title" *ngIf="!update">Nuevo</div>
    <div class="modal-title" *ngIf="update">Actualizar Cuarto: {{ room }}</div>
    <button class="close" aria-label="Close" (click)="d('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <form #myForm="ngForm">
      <div class="row-fluid">
        <div class="form-group row mt-2" *ngIf="!update">
          <label class="col-sm-3 col-form-label">Desde Cuarto</label>
          <div class="col-sm-6">
            <kendo-combobox [data]="rooms" [textField]="'cuarto'" [valueField]="'cuarto'"
              (valueChange)="toRoomValue($event)" class="w-100" name="toRoom" [(ngModel)]="toRoom" [disabled]="update"
              required>
            </kendo-combobox>
          </div>
        </div>
        <div class="form-group row" *ngIf="!update">
          <label class="col-sm-3 col-form-label">Hasta Cuarto</label>
          <div class="col-sm-6">
            <kendo-combobox [data]="rooms" [textField]="'cuarto'" [valueField]="'cuarto'"
              (valueChange)="fromRoomValue($event)" class="w-100" name="fromRoom" [(ngModel)]="fromRoom"
              [disabled]="update || !toRoom" required>
            </kendo-combobox>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Fecha Inicio</label>
          <div class="col-sm-9">
            <kendo-datepicker [format]="formatKendo" [(ngModel)]="toFday" [disabled]="update" name="toFday" required
              (valueChange)="toDateValue($event)">
            </kendo-datepicker>
            <i class="col-sm-3 h6 ml-2">{{ dayOfWeek1 }}</i>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Días</label>
          <div class="col-6 col-sm-3 col-md-3">
            <input type="number" min="0" class="form-control" value="1" name="totalDays" [(ngModel)]="totalDays"
              (keyup)=totalOfDays(days.value) (change)="totalOfDays(days.value)" #days>
          </div>
          <div class="col-2 col-md-1">
            <button class="btn btn-secondary btn-block" (click)="totalOfDays(days.value, '+')">
              <i class="fas fa-plus"></i>
            </button>
          </div>
          <div class="col-2 col-md-1">
            <button class="btn btn-secondary btn-block" (click)="totalOfDays(days.value, '-')">
              <i class="fas fa-minus"></i>
            </button>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Fecha Término</label>
          <div class="col-sm-9">
            <kendo-datepicker [format]="formatKendo" [(ngModel)]="fromFday" [min]="toFday" name="fromFday" required
              (valueChange)="fromDateValue($event)">
            </kendo-datepicker>
            <i class="col-sm-3 h6 ml-2">{{ dayOfWeek2 }}</i>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Razón</label>
          <div class="col-sm-9">
            <textarea class="form-control" name="crazon" rows="2" [(ngModel)]="crazon" required></textarea>
          </div>
        </div>
      </div>
    </form>
  </div>
  <div class="modal-footer">
    <button class="btn btn-success mr-1" [disabled]="!myForm.valid" (click)="saveRecord(myForm)">
      <i class="fa fa-save mr-2"></i>Guardar
    </button>
    <button (click)="c()" class="btn btn-secondary">
      Cerrar
    </button>
  </div>
</ng-template>